/* $Id$ */

/*========================================================================
 *  Copyright (c) Michael J. Hammel 1995-2001
 *========================================================================
 *              FILE NAME: prototypes.h
 *            DESCRIPTION: External function definitions
 *                  NOTES: 
 *
 * SPECIAL CONSIDERATIONS:
 *========================================================================
 *
 * MODIFICATION HISTORY:
 * $Log$
 *
 *========================================================================*/
#ifndef XP_PROTOS_H
#define XP_PROTOS_H

#ifndef XP_NOTES_C
extern void XPCreateNewNote();
extern void XPRaiseNotes();
extern void XPRaiseAllNotes();
extern void XPLowerNotes();
extern void XPLowerAllNotes();
extern void XPSaveAllNotes();
extern void XPUnHideAllNotes();
extern void XPHideAllNotes();
extern void XPCascadeNotes();
extern void XPMakeNoteListCB();
extern void	XPMakeNoteWidget();
extern void XPAnchorNote();
extern void XPUnAnchorNote();
extern void	XPDestroyNote();
extern void	XPSetSaveSensitive();
extern void	XPTearOff();
extern void XPHideNote();
extern void XPEraseNote();
extern void XPSaveNote();
extern void XPGetNotePosition();
extern StickyNote	*XPFindNote();
extern StickyNote	*XPAllocNote();
#endif /* XP_NOTES_C */


#ifndef XP_BINDINGS_C
extern void XPActionAlarm();
extern void XPActionAnchor();
extern void XPActionDestroy();
extern void XPActionHide();
extern void XPActionErase();
extern void XPActionCal();
extern void XPActionSave();
extern void XPActionPrint();
extern void XPActionOpen();
extern void XPActionEnvelope();
extern void XPActionProject();
extern void XPActionFind();
extern void XPActionName();
extern void XPActionDate();
extern void XPActionEmail();
extern void XPActionExport();
extern void XPActionAddressManager();
extern void XPSetNoteName();
extern void XPSendNote();
#endif /* XP_BINDINGS_C */


#ifndef XP_MENUS_C
extern void XPCreateMainMenu();
extern int XPButtonPress();
#endif /* XP_MENUS_C */


#ifndef XP_UTILS_C
extern void			*XPInsertText();
extern void			XPShutdown();
extern void			XPCenterWindow();
extern int			XPLaunchIcal();

extern GtkWidget	*XPMultiLineText();
extern GtkWidget	*XPGtkNameToWidget();
extern int			XPNoop2();
extern void			XPGTKShowDisabledCmds();
extern int			XPFind();
extern int			XPUpdateInsertPtr();

#endif /* XP_UTILS_C */


#ifndef XP_PLAID_C
extern GtkWidget	*XPCreatePlaidWidget();
#endif /* XP_PLAID_C */


#ifndef XP_TODOS_S
extern void	XPTodos();
#endif /* XP_TODO_S */


#ifndef XP_LOADSAVE_C
extern void	XPLoadSavedNotes();
#endif /* XP_LOADSAVE_C */

#ifndef XP_TT_C
extern void	XPToolTips();
#endif /* XP_TT_C */

#ifndef XP_FINDTEXT_C
extern void	XPFindTextPrompt();
#endif /* XP_FINDTEXT_C */

#ifndef XP_PROJECTS_C
extern void	XPProject();
extern void	XPNoteProject();
extern void	XPUpdateColorBox();
extern void	XPUpdateProject();
#endif /* XP_PROJECTS_C */

#ifndef XP_TIMERCB_C
extern void	XPAutoSave();
extern void	XPAlarmCheck();
extern void	XPCreateTimerPrompt();
extern void XPAlarmOff();
#endif /* XP_TIMERCB_C */


#ifndef XP_ERRDIALOG_C
extern void XPErrPopDown();
#endif /* XP_ERRDIALOG_C */


#ifndef XP_FINDNOTE_C
extern void	XPCreateFindNotePrompt();
extern void	XPGenericNoteList();
#endif /* XP_FINDNOTE_C */

#ifndef XP_CONFIRM_C
extern void	XPConfirmIt();
extern void	XPConfirmDialogClose();
#endif /* XP_CONFIRM_C */


#ifndef XP_COLORS_C
extern int	XPSetGlobalColors();
#endif /* XP_COLORS_C */


#ifndef XP_IO_C
extern void	XPOpenNote();
extern void	XPExportNote();
#endif /* XP_IO_C */


#ifndef XP_PRINT_C
extern void	XPPrintNote();
#endif /* XP_PRINT_C */


#ifndef XP_NAME_C
extern void	XPNameNote();
extern void	XPUpdateName();
#endif /* XP_NAME_C */


#ifndef XP_INSERTS_C
extern void	XPInsertDates();
extern void	XPInsertCalendar();
#endif /* XP_INSERTS_C */


#ifndef XP_EMAIL_C
extern void	XPCreateEmailNotePrompt();
extern void	XPEmailNote();
extern void	XPFillEmailList();
#endif /* XP_EMAIL_C */


#ifndef XP_CONFIG_C
extern void	XPReadConfigFile();
#endif /* XP_CONFIG_C */


#ifndef XP_AUDIO_C
extern void	XPSetUpAudio();
#endif /* XP_AUDIO_C */


#ifndef XP_ENVELOPE_C
extern void	XPEnvelope();
extern void	XPUpdateToText();
#endif /* XP_ENVELOPE_C */

#ifndef XP_DIALOG_C
extern void	XPMsgWindow();
extern void	XPCloseMsgWindow();
#endif /* XP_DIALOG_C */

#ifndef XP_ABOUT_C
extern int XPAbout();
extern int XPRegisterPopUp();
#endif /* XP_ABOUT_C */

#ifndef XP_CALENDAR_C
extern void XPShowCalendar();
extern void XPCalendarUpdate();
extern void XPCalendarGetDate();
extern void XPCloseCalendar();
#endif /* XP_CALENDAR_C */

#ifndef XP_PILOT_C
extern void XPPilot();
#endif /* XP_PILOT_C */

#ifndef XP_PADDR_C
extern int XPPilotParseAddr();
extern int XPPilotParseTodo();
extern int XPPilotParseMemos();
extern void XPWriteTodos();
#endif /* XP_PADDR_C */

#ifndef XP_ADDR_MGR_C
extern int XPAddressManager();
extern int XPUpdateAddrList();
#endif /* XP_ADDR_MGR_C */

#ifndef XP_ADDR_EDITOR_C
extern int XPAddressEditor();
extern int XPCloseAddrEditor();
#endif /* XP_ADDR_EDITOR_C */

#ifndef XP_SPELLCHECK_C
extern GtkWidget	*XPSpellCheckPrompt();
#endif /* XP_SPELLCHECK_C */

#ifndef XP_GENERIC_C
extern GtkWidget	*XPCreateGenericShell();
#endif /* XP_GENERIC_C */

/*
 * Common files (in libxncommon)
 */
#ifndef XP_CUTILS_S
extern char			*XPSafeAlloc();
extern void			*XPSetNoteDir();
extern char			*XPMakeFname();
extern void 		XPPopUpList();
extern void			XPNoop();
extern void			XPRingBell();
extern void			XPErrPopUp();
extern void			XPShowDisabledCmds();
extern int			XPTestCmd();
extern void			XPFixUpPath();
extern void			XPConvertCase();
extern int			XPFindString();
#endif /* XP_CUTILS_S */

#ifndef XP_C_C
extern void			XPValidateAppRes();
extern void			XPShowDefaults();
#endif /* XP_C_C */

#ifndef XP_CPROJECTS_S
extern void	XPSetUpProjects();
extern void	XPWriteProjects();
#endif /* XP_CPROJECTS_S */

#ifndef XP_CPADDR_C
extern void XPFreeMemoList();
extern void XPWriteMemos();
extern void XPWriteAddresses();
extern void XPAddAddress();
extern void XPFreeCategoryList();
extern void XPFreeAddressList();
extern void XPGenerateMemoCategoryList();
#endif /* XP_CPADDR_C */

#endif /* XP_PROTOS_H */
