#define CONFIG_FILE_HDR \
"# Default configuration file for GTK version of XNotesPlus\n\
# Should be placed in your $HOME/.xnotesplus directory or set XPCONFIGFILE\n\
# to specify where to find it.\n\
#\n\
# This file uses name:value pairs to establish the configuration parameters\n\
# for XNotesPlus.  The names are case insensitive, but the values are not.\n\
# This file overrides the program defaults, but values here can be\n\
# overridden by command line options.\n\
#\n\
# Lines beginning with a # are ignored.  Leading white space is ignored.\n\
# Blank lines are ignored.  No spaces are allowed between the colon (:)\n\
# and values.  In other words:\n\
# name: value -- invalid\n\
# name:value  -- valid\n\
#\n\
# Note: GTK doesn't have a resource parser like Xt/Motif, thus the need\n\
# for this file to accompany the gtkrc file.\n\
# \n\
# The latest version of XNotesPlus can always be found at the download site: \n\
# \n\
# http://www.graphics-muse.org/xnotes/download.html\n\
#"

#define CONFIG_FILE_DONT_CHANGE \
"###\n\
### The following items should not be changed.\n\
###"


#define CONFIG_FILE_HELP_AUDIO \
"### If NoAudio = \"no\" then use audio alarms; otherwise don't use audio alarms"

#define CONFIG_FILE_HELP_SAVE_INTERVAL \
"### Do you want to automatically save modified XNotes?  If so, how often\n\
### should automatic saves occur (in seconds)?"

#define CONFIG_FILE_HELP_SAVE_EXIT \
"### Save on Exit - YES causes modified (but not yet saved) xnotes to 
### automatically be saved when you exit the program."

#define CONFIG_FILE_HELP_ALARMS \
"### Alarm - if ON, allows the use of alarms with xnotes. Not much reason to\n\
### turn this off, really.  You don't *have* to use it, but with it turned\n\
### off you don't even get that option."

#define CONFIG_FILE_HELP_NOTICE \
"### Notice - If set to OFF then you won't get the dialog that says which\n\
### features are disabled when you start XNotesPlus."

#define CONFIG_FILE_HELP_TOOLTIPS \
"### Default state for XNotesPlus tooltips.  If set to ON, tooltips are on.\n\
### Otherwise they are set to off."

#define CONFIG_FILE_HELP_PRINTER \
"### What command should be used to print from XNotesPlus?"

#define CONFIG_FILE_HELP_EMAIL \
"### What command should be used to email xnotes from XNotesPlus?"

#define CONFIG_FILE_HELP_CALENDAR \
"### What command should be used to insert calendars into xnotes from \n\
### XNotesPlus?"

#define CONFIG_FILE_HELP_ICAL \
"### What command should be used to launch the external calendar program?\n\
### Usually this is \"ical\", which can be found at the XNotesPlus download\n\
### site."

#define CONFIG_FILE_HELP_GTKRC \
"### Where is the GTKRC file we should use by default?"

#define CONFIG_FILE_HELP_SPELL \
"### What ispell-compatible command should we use to do spell checking?\n\
### If this command is not found, then spell checking for Xnotes is disabled."

#define CHMOD_CMD_STRING	\
"chmod 600 %s/History; \
chmod 600 %s/COPYING; \
chmod 600 %s/XNotesPlus.*; \
chmod 600 %s/xnprojects*; \
chmod -R 755 %s/bin; \
chmod 755 %s/docs-d; \
chmod 644 %s/docs-d/*; \
chmod 755 %s/docs-d/html; \
chmod 644 %s/docs-d/html/*; \
chmod 755 %s/docs-d/html/images; \
chmod 644 %s/docs-d/html/images/*; \
chmod 755 %s/xpm-d; \
chmod 644 %s/xpm-d/*; \
chmod 755 %s/audio-d; \
chmod 644 %s/audio-d/*; \
chmod 755 %s/pilot; \
chmod 644 %s/pilot/*"

#define INSTALL_COMPLETE \
"Congratulations!  XNotesPlus is now installed and ready to run. \n\
Just type \"xnotes+\", or if you didn't install the program in a \n\
directory in your path, you can type %s/xnotes+ instead. \n\
\n\
If you have any comments or questions, please feel free to contact \n\
me at mjhammel@graphics-muse.org. \n\
"
